Index: pykota/trunk/docs/pykota.sgml
===================================================================
--- pykota/trunk/docs/pykota.sgml (revision 1118)
+++ pykota/trunk/docs/pykota.sgml (revision 1189)
@@ -7,5 +7,5 @@
   <!entity WARNPYKOTA system "warnpykota.sgml">
   <!entity FILTERPYKOTA system "filterpykota.sgml">
-  <!entity GNUFDL system "gnufdl.sgml">
+  <!entity GNUGPL system "gnugpl.sgml">
 
 ]>
@@ -53,11 +53,31 @@
 
       <para>
-        Permission is granted to copy, distribute and/or modify this document
-        under the terms of the GNU Free Documentation License, Version 1.1
-        or any later version published by the Free Software Foundation;
-        with no Invariant Sections, with no
-        Front-Cover Texts, and with no Back-Cover Texts.
-        A copy of the license is included in the section entitled "GNU
-        Free Documentation License".
+        This documentation is licensed under the terms of the GNU 
+        General Public License as described below.
+      </para>
+      
+      <para>
+        This program is free software; you can redistribute it and/or modify
+        it under the terms of the GNU General Public License as published by
+        the Free Software Foundation; either version 2 of the License, or
+        (at your option) any later version.
+      </para>  
+
+      <para>
+        This program is distributed in the hope that it will be useful,
+        but WITHOUT ANY WARRANTY; without even the implied warranty of
+        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+        GNU General Public License for more details.
+      </para>  
+
+      <para>
+        You should have received a copy of the GNU General Public License
+        along with this program; if not, write to the Free Software
+        Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.
+      </para>
+      
+      <para>
+        A copy of the entire license is included in the section entitled "GNU
+        General Public License".
       </para>
 
@@ -91,5 +111,5 @@
   &WARNPYKOTA;
     
-  &GNUFDL;
+  &GNUGPL;
 
 </book>
@@ -98,4 +118,7 @@
 
 $Log$
+Revision 1.9  2003/11/18 08:39:49  jalet
+Documentation's licensed changed from GNU FDL to GNU GPL, to please Debian.
+
 Revision 1.8  2003/08/18 19:20:19  jalet
 I don't know what I did, but I know this was incorrect !
Index: pykota/trunk/docs/gnugpl.sgml
===================================================================
--- pykota/trunk/docs/gnugpl.sgml (revision 1189)
+++ pykota/trunk/docs/gnugpl.sgml (revision 1189)
@@ -0,0 +1,430 @@
+<!-- 
+     The GNU Public License 2 in DocBook
+     Markup by Eric Baudais <baudais@okstate.edu>
+     Maintained by the GNOME Documentation Project
+     http://developer.gnome.org/projects/gdp
+     Version: 1.0.1
+     Last Modified: Nov 16, 2000
+-->
+
+<appendix id="gpl">
+  <docinfo>
+    <releaseinfo>
+      Version 2, June 1991
+    </releaseinfo>
+    <copyright>
+      <year>2000</year>
+      <holder>Free Software Foundation, Inc.</holder>
+    </copyright>
+    <legalnotice id="gpl-legalnotice">
+      <para>
+	<address>Free Software Foundation, Inc. 
+	  <street>59 Temple Place, Suite 330</street>, 
+	  <city>Boston</city>, 
+	  <state>MA</state> <postcode>02111-1307</postcode>
+	  <country>USA</country>
+	</address>.
+      </para>
+      <para>
+	Everyone is permitted to copy and distribute verbatim copies
+	of this license document, but changing it is not allowed.
+      </para>
+    </legalnotice>
+  </docinfo>
+  <title>GNU General Public License</title>
+
+  <sect1 id="gpl-preamble">
+    <title>Preamble</title>
+    
+    <para>
+      The licenses for most software are designed to take away your 
+      freedom to share and change it. By contrast, the GNU General Public 
+      License is intended to guarantee your freedom to share and change 
+      free software - to make sure the software is free for all its users. 
+      This General Public License applies to most of the Free Software 
+      Foundation's software and to any other program whose authors commit 
+      to using it. (Some other Free Software Foundation software is covered 
+      by the GNU Library General Public License instead.) You can apply it 
+      to your programs, too.
+    </para>
+
+    <para>
+      When we speak of free software, we are referring to freedom, not price. 
+      Our General Public Licenses are designed to make sure that you have the 
+      freedom to distribute copies of free software (and charge for this 
+      service if you wish), that you receive source code or can get it if you 
+      want it, that you can change the software or use pieces of it in new free 
+      programs; and that you know you can do these things.
+    </para>
+
+    <para>
+      To protect your rights, we need to make restrictions that forbid anyone 
+      to deny you these rights or to ask you to surrender the rights. These 
+      restrictions translate to certain responsibilities for you if you distribute 
+      copies of the software, or if you modify it.
+    </para>
+
+    <para>
+      For example, if you distribute copies of such a program, whether gratis or 
+      for a fee, you must give the recipients all the rights that you have. You 
+      must make sure that they, too, receive or can get the source code. And you 
+      must show them these terms so they know their rights.
+    </para>
+
+    <para>
+      We protect your rights with two steps:
+
+      <orderedlist numeration="arabic">
+	<listitem>
+	  <para>
+	    copyright the software, and
+	  </para>
+	</listitem>
+	<listitem>
+	  <para>
+	    offer you this license which gives you legal permission to copy, 
+	    distribute and/or modify the software.
+	  </para>
+	</listitem>
+      </orderedlist>
+    </para>
+
+    <para>
+      Also, for each author's protection and ours, we want to make certain that 
+      everyone understands that there is no warranty for this free software. If 
+      the software is modified by someone else and passed on, we want its 
+      recipients to know that what they have is not the original, so that any 
+      problems introduced by others will not reflect on the original authors' 
+      reputations.
+    </para>
+
+    <para>
+      Finally, any free program is threatened constantly by software patents. 
+      We wish to avoid the danger that redistributors of a free program will 
+      individually obtain patent licenses, in effect making the program 
+      proprietary. To prevent this, we have made it clear that any patent must be 
+      licensed for everyone's free use or not licensed at all.
+    </para>
+
+    <para>
+      The precise terms and conditions for copying, distribution and modification 
+      follow.
+    </para>
+
+  </sect1>
+
+  <sect1 id="gpl-terms">
+    <title>TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION</title>
+
+    <sect2 id="gpl-sect0">
+      <title>Section 0</title>
+      <para>
+	This License applies to any program or other work which contains a notice 
+	placed by the copyright holder saying it may be distributed under the terms 
+	of this General Public License. The "Program", below, refers to any such 
+	program or work, and a <quote>work based on the Program</quote> means either 
+	the Program or any derivative work under copyright law: that is to say, a 
+	work containing the Program or a portion of it, either verbatim or with 
+	modifications and/or translated into another language. (Hereinafter, translation 
+	is included without limitation in the term <quote>modification</quote>.) Each 
+	licensee is addressed as <quote>you</quote>.
+      </para>
+
+      <para>
+	Activities other than copying, distribution and modification are not covered by 
+	this License; they are outside its scope. The act of running the Program is not 
+	restricted, and the output from the Program is covered only if its contents 
+	constitute a work based on the Program (independent of having been made by running 
+	the Program). Whether that is true depends on what the Program does.
+      </para>
+    </sect2>
+
+    <sect2 id="gpl-sect1">
+      <title>Section 1</title>
+      <para>
+	You may copy and distribute verbatim copies of the Program's source code as you 
+	receive it, in any medium, provided that you conspicuously and appropriately 
+	publish on each copy an appropriate copyright notice and disclaimer of warranty; 
+	keep intact all the notices that refer to this License and to the absence of any 
+	warranty; and give any other recipients of the Program a copy of this License 
+	along with the Program.
+      </para>
+      
+      <para>
+	You may charge a fee for the physical act of transferring a copy, and you may at 
+	your option offer warranty protection in exchange for a fee.
+      </para>
+    </sect2>
+
+    <sect2 id="gpl-sect2">
+      <title>Section 2</title>
+      <para>
+	You may modify your copy or copies of the Program or any portion of it, thus 
+	forming a work based on the Program, and copy and distribute such modifications 
+	or work under the terms of <link linkend="gpl-sect1">Section 1</link> above, provided 
+	that you also meet all of these conditions:
+
+	<orderedlist numeration="loweralpha">
+	  <listitem>
+	    <para>
+	      You must cause the modified files to carry prominent notices stating that 
+	      you changed the files and the date of any change.
+	    </para>
+	  </listitem>
+	  <listitem>
+	    <para>
+	      You must cause any work that you distribute or publish, that in whole or 
+	      in part contains or is derived from the Program or any part thereof, to be 
+	      licensed as a whole at no charge to all third parties under the terms of 
+	      this License.
+	    </para>
+	  </listitem>
+	  <listitem>
+	    <para>
+	      If the modified program normally reads commands interactively when run, you 
+	      must cause it, when started running for such interactive use in the most 
+	      ordinary way, to print or display an announcement including an appropriate 
+	      copyright notice and a notice that there is no warranty (or else, saying 
+	      that you provide a warranty) and that users may redistribute the program 
+	      under these conditions, and telling the user how to view a copy of this 
+	      License. 
+
+	      <note>
+		<title>Exception:</title>
+		<para>
+		  If the Program itself is interactive but does not normally print such an 
+		  announcement, your work based on the Program is not required to print an 
+		  announcement.) 
+		</para>
+	      </note>
+
+	    </para>
+	  </listitem>
+	</orderedlist>
+      </para>
+
+      <para>
+	These requirements apply to the modified work as a whole. If identifiable sections 
+	of that work are not derived from the Program, and can be reasonably considered 
+	independent and separate works in themselves, then this License, and its terms, 
+	do not apply to those sections when you distribute them as separate works. But when 
+	you distribute the same sections as part of a whole which is a work based on the 
+	Program, the distribution of the whole must be on the terms of this License, whose 
+	permissions for other licensees extend to the entire whole, and thus to each and 
+	every part regardless of who wrote it.
+      </para>
+
+      <para>
+	Thus, it is not the intent of this section to claim rights or contest your rights 
+	to work written entirely by you; rather, the intent is to exercise the right to control 
+	the distribution of derivative or collective works based on the Program.
+      </para>
+
+      <para>
+	In addition, mere aggregation of another work not based on the Program with the Program 
+	(or with a work based on the Program) on a volume of a storage or distribution medium 
+	does not bring the other work under the scope of this License.
+      </para>
+    </sect2>
+
+    <sect2 id="gpl-sect3">
+      <title>Section 3</title>
+
+      <para>
+	You may copy and distribute the Program (or a work based on it, under 
+	<link linkend="gpl-sect2">Section 2</link> in object code or executable form under the terms of 
+	<link linkend="gpl-sect1">Sections 1</link> and <link linkend="gpl-sect2">2</link> above provided that 
+	you also do one of the following:
+
+	<orderedlist numeration="loweralpha">
+	  <listitem>
+	    <para>
+	      Accompany it with the complete corresponding machine-readable source code, which 
+	      must be distributed under the terms of Sections 1 and 2 above on a medium 
+	      customarily used for software interchange; or,
+	    </para>
+	  </listitem>
+	  <listitem>
+	    <para>
+	      Accompany it with a written offer, valid for at least three years, to give any 
+	      third party, for a charge no more than your cost of physically performing source 
+	      distribution, a complete machine-readable copy of the corresponding source code, 
+	      to be distributed under the terms of Sections 1 and 2 above on a medium customarily 
+	      used for software interchange; or,
+	    </para>
+	  </listitem>
+	  <listitem>
+	    <para>
+	      Accompany it with the information you received as to the offer to distribute 
+	      corresponding source code. (This alternative is allowed only for noncommercial 
+	      distribution and only if you received the program in object code or executable form 
+	      with such an offer, in accord with Subsection b above.)
+	    </para>
+	  </listitem>
+	</orderedlist>
+      </para>
+
+      <para>
+	The source code for a work means the preferred form of the work for making modifications 
+	to it. For an executable work, complete source code means all the source code for all modules 
+	it contains, plus any associated interface definition files, plus the scripts used to control 
+	compilation and installation of the executable. However, as a special exception, the source 
+	code distributed need not include anything that is normally distributed (in either source or 
+	binary form) with the major components (compiler, kernel, and so on) of the operating system 
+	on which the executable runs, unless that component itself accompanies the executable.
+      </para>
+      
+      <para>
+	If distribution of executable or object code is made by offering access to copy from a 
+	designated place, then offering equivalent access to copy the source code from the same place 
+	counts as distribution of the source code, even though third parties are not compelled to 
+	copy the source along with the object code.
+      </para>
+    </sect2>
+
+    <sect2 id="gpl-sect4">
+      <title>Section 4</title>
+      
+      <para>
+	You may not copy, modify, sublicense, or distribute the Program except as expressly provided 
+	under this License. Any attempt otherwise to copy, modify, sublicense or distribute the 
+	Program is void, and will automatically terminate your rights under this License. However, 
+	parties who have received copies, or rights, from you under this License will not have their 
+	licenses terminated so long as such parties remain in full compliance.
+      </para>
+    </sect2>
+
+    <sect2 id="gpl-sect5">
+      <title>Section 5</title>
+
+      <para>
+	You are not required to accept this License, since you have not signed it. However, nothing 
+	else grants you permission to modify or distribute the Program or its derivative works. 
+	These actions are prohibited by law if you do not accept this License. Therefore, by modifying 
+	or distributing the Program (or any work based on the Program), you indicate your acceptance 
+	of this License to do so, and all its terms and conditions for copying, distributing or 
+	modifying the Program or works based on it.
+      </para>
+    </sect2>
+
+    <sect2 id="gpl-sect6">
+      <title>Section 6</title>
+
+      <para>
+	Each time you redistribute the Program (or any work based on the Program), the recipient 
+	automatically receives a license from the original licensor to copy, distribute or modify 
+	the Program subject to these terms and conditions. You may not impose any further restrictions 
+	on the recipients' exercise of the rights granted herein. You are not responsible for enforcing 
+	compliance by third parties to this License.
+      </para>
+    </sect2>
+
+    <sect2 id="gpl-sect7">
+      <title>Section 7</title>
+
+      <para>
+	If, as a consequence of a court judgment or allegation of patent infringement or for any other 
+	reason (not limited to patent issues), conditions are imposed on you (whether by court order, 
+	agreement or otherwise) that contradict the conditions of this License, they do not excuse you 
+	from the conditions of this License. If you cannot distribute so as to satisfy simultaneously 
+	your obligations under this License and any other pertinent obligations, then as a consequence 
+	you may not distribute the Program at all. For example, if a patent license would not permit 
+	royalty-free redistribution of the Program by all those who receive copies directly or 
+	indirectly through you, then the only way you could satisfy both it and this License would be 
+	to refrain entirely from distribution of the Program.
+      </para>
+
+      <para>
+	If any portion of this section is held invalid or unenforceable under any particular circumstance, 
+	the balance of the section is intended to apply and the section as a whole is intended to apply 
+	in other circumstances.
+      </para>
+
+      <para>
+	It is not the purpose of this section to induce you to infringe any patents or other property 
+	right claims or to contest validity of any such claims; this section has the sole purpose of 
+	protecting the integrity of the free software distribution system, which is implemented by public 
+	license practices. Many people have made generous contributions to the wide range of software 
+	distributed through that system in reliance on consistent application of that system; it is up 
+	to the author/donor to decide if he or she is willing to distribute software through any other 
+	system and a licensee cannot impose that choice.
+      </para>
+
+      <para>
+	This section is intended to make thoroughly clear what is believed to be a consequence of the 
+	rest of this License.
+      </para>
+    </sect2>
+
+    <sect2 id="gpl-sect8">
+      <title>Section 8</title>
+
+      <para>
+	If the distribution and/or use of the Program is restricted in certain countries either by patents 
+	or by copyrighted interfaces, the original copyright holder who places the Program under this License 
+	may add an explicit geographical distribution limitation excluding those countries, so that 
+	distribution is permitted only in or among countries not thus excluded. In such case, this License 
+	incorporates the limitation as if written in the body of this License.
+      </para>
+    </sect2>
+
+    <sect2 id="gpl-sect9">
+      <title>Section 9</title>
+      
+      <para>
+	The Free Software Foundation may publish revised and/or new versions of the General Public License 
+	from time to time. Such new versions will be similar in spirit to the present version, but may differ 
+	in detail to address new problems or concerns.
+      </para>
+
+      <para>
+	Each version is given a distinguishing version number. If the Program specifies a version number of 
+	this License which applies to it and "any later version", you have the option of following the terms 
+	and conditions either of that version or of any later version published by the Free Software 
+	Foundation. If the Program does not specify a version number of this License, you may choose any 
+	version ever published by the Free Software Foundation.
+      </para>
+    </sect2>
+
+    <sect2 id="gpl-sect10">
+      <title>Section 10</title>
+
+      <para>
+	If you wish to incorporate parts of the Program into other free programs whose distribution 
+	conditions are different, write to the author to ask for permission. For software which is copyrighted 
+	by the Free Software Foundation, write to the Free Software Foundation; we sometimes make exceptions 
+	for this. Our decision will be guided by the two goals of preserving the free status of all 
+	derivatives of our free software and of promoting the sharing and reuse of software generally.
+      </para>
+    </sect2>
+
+    <sect2 id="gpl-sect11">
+      <title>NO WARRANTY</title>
+      <subtitle>Section 11</subtitle>
+
+      <para>
+	BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY FOR THE PROGRAM, TO THE EXTENT 
+	PERMITTED BY APPLICABLE LAW. EXCEPT WHEN OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR 
+	OTHER PARTIES PROVIDE THE PROGRAM "AS IS" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, 
+	INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR 
+	PURPOSE. THE ENTIRE RISK AS TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU. SHOULD THE 
+	PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING, REPAIR OR CORRECTION.
+      </para>
+    </sect2>
+
+    <sect2 id="gpl-sect12">
+      <title>Section 12</title>
+
+      <para>
+	IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING WILL ANY COPYRIGHT HOLDER, OR 
+	ANY OTHER PARTY WHO MAY MODIFY AND/OR REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU 
+	FOR DAMAGES, INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING OUT OF THE 
+	USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED TO LOSS OF DATA OR DATA BEING RENDERED 
+	INACCURATE OR LOSSES SUSTAINED BY YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH 
+	ANY OTHER PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH 
+	DAMAGES.
+      </para>
+    </sect2>
+  </sect1>
+</appendix>
+
Index: pykota/trunk/docs/gnufdl.sgml
===================================================================
--- pykota/trunk/docs/gnufdl.sgml (revision 753)
+++  (revision )
@@ -1,450 +1,0 @@
-<appendix id="gfdl">
-<title>GNU Free Documentation License</title>
-<!-- - GNU Project - Free Software Foundation (FSF) -->
-<!-- LINK REV="made" HREF="mailto:webmasters@gnu.org" -->
-
-
-  <!-- sect1>
-    <title>GNU Free Documentation License</title -->
-
-    <para>Version 1.1, March 2000</para>
-
-    <blockquote>
-      <para>Copyright (C) 2000  Free Software Foundation, Inc.
-59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
-Everyone is permitted to copy and distribute verbatim copies
-of this license document, but changing it is not allowed.</para>
-    </blockquote>
-
-  <sect1 label="0">
-    <title>PREAMBLE</title>
-
-    <para>The purpose of this License is to make a manual, textbook,
-    or other written document "free" in the sense of freedom: to
-    assure everyone the effective freedom to copy and redistribute it,
-    with or without modifying it, either commercially or
-    noncommercially.  Secondarily, this License preserves for the
-    author and publisher a way to get credit for their work, while not
-    being considered responsible for modifications made by
-    others.</para>
-
-    <para>This License is a kind of "copyleft", which means that
-    derivative works of the document must themselves be free in the
-    same sense.  It complements the GNU General Public License, which
-    is a copyleft license designed for free software.</para>
-
-    <para>We have designed this License in order to use it for manuals
-    for free software, because free software needs free documentation:
-    a free program should come with manuals providing the same
-    freedoms that the software does.  But this License is not limited
-    to software manuals; it can be used for any textual work,
-    regardless of subject matter or whether it is published as a
-    printed book.  We recommend this License principally for works
-    whose purpose is instruction or reference.</para>
-  </sect1>
-
-  <sect1 label="1">
-    <title>APPLICABILITY AND DEFINITIONS</title>
-
-    <para>This License applies to any manual or other work that
-    contains a notice placed by the copyright holder saying it can be
-    distributed under the terms of this License.  The "Document",
-    below, refers to any such manual or work.  Any member of the
-    public is a licensee, and is addressed as "you".</para>
-
-    <para>A "Modified Version" of the Document means any work
-    containing the Document or a portion of it, either copied
-    verbatim, or with modifications and/or translated into another
-    language.</para>
-
-    <para>A "Secondary Section" is a named appendix or a front-matter
-    section of the Document that deals exclusively with the
-    relationship of the publishers or authors of the Document to the
-    Document's overall subject (or to related matters) and contains
-    nothing that could fall directly within that overall subject.
-    (For example, if the Document is in part a textbook of
-    mathematics, a Secondary Section may not explain any mathematics.)
-    The relationship could be a matter of historical connection with
-    the subject or with related matters, or of legal, commercial,
-    philosophical, ethical or political position regarding
-    them.</para>
-
-    <para>The "Invariant Sections" are certain Secondary Sections
-    whose titles are designated, as being those of Invariant Sections,
-    in the notice that says that the Document is released under this
-    License.</para>
-
-    <para>The "Cover Texts" are certain short passages of text that
-    are listed, as Front-Cover Texts or Back-Cover Texts, in the
-    notice that says that the Document is released under this
-    License.</para>
-
-    <para>A "Transparent" copy of the Document means a
-    machine-readable copy, represented in a format whose specification
-    is available to the general public, whose contents can be viewed
-    and edited directly and straightforwardly with generic text
-    editors or (for images composed of pixels) generic paint programs
-    or (for drawings) some widely available drawing editor, and that
-    is suitable for input to text formatters or for automatic
-    translation to a variety of formats suitable for input to text
-    formatters.  A copy made in an otherwise Transparent file format
-    whose markup has been designed to thwart or discourage subsequent
-    modification by readers is not Transparent.  A copy that is not
-    "Transparent" is called "Opaque".</para>
-
-    <para>Examples of suitable formats for Transparent copies include
-    plain ASCII without markup, Texinfo input format, LaTeX input
-    format, SGML or XML using a publicly available DTD, and
-    standard-conforming simple HTML designed for human modification.
-    Opaque formats include PostScript, PDF, proprietary formats that
-    can be read and edited only by proprietary word processors, SGML
-    or XML for which the DTD and/or processing tools are not generally
-    available, and the machine-generated HTML produced by some word
-    processors for output purposes only.</para>
-
-    <para>The "Title Page" means, for a printed book, the title page
-    itself, plus such following pages as are needed to hold, legibly,
-    the material this License requires to appear in the title page.
-    For works in formats which do not have any title page as such,
-    "Title Page" means the text near the most prominent appearance of
-    the work's title, preceding the beginning of the body of the
-    text.</para>
-  </sect1>
-
-  <sect1 label="2">
-    <title>VERBATIM COPYING</title>
-
-    <para>You may copy and distribute the Document in any medium,
-    either commercially or noncommercially, provided that this
-    License, the copyright notices, and the license notice saying this
-    License applies to the Document are reproduced in all copies, and
-    that you add no other conditions whatsoever to those of this
-    License.  You may not use technical measures to obstruct or
-    control the reading or further copying of the copies you make or
-    distribute.  However, you may accept compensation in exchange for
-    copies.  If you distribute a large enough number of copies you
-    must also follow the conditions in section 3.</para>
-
-    <para>You may also lend copies, under the same conditions stated
-    above, and you may publicly display copies.</para>
-  </sect1>
-
-  <sect1 label="3">
-    <title>COPYING IN QUANTITY</title>
-
-    <para>If you publish printed copies of the Document numbering more
-    than 100, and the Document's license notice requires Cover Texts,
-    you must enclose the copies in covers that carry, clearly and
-    legibly, all these Cover Texts: Front-Cover Texts on the front
-    cover, and Back-Cover Texts on the back cover.  Both covers must
-    also clearly and legibly identify you as the publisher of these
-    copies.  The front cover must present the full title with all
-    words of the title equally prominent and visible.  You may add
-    other material on the covers in addition.  Copying with changes
-    limited to the covers, as long as they preserve the title of the
-    Document and satisfy these conditions, can be treated as verbatim
-    copying in other respects.</para>
-
-    <para>If the required texts for either cover are too voluminous to
-    fit legibly, you should put the first ones listed (as many as fit
-    reasonably) on the actual cover, and continue the rest onto
-    adjacent pages.</para>
-
-    <para>If you publish or distribute Opaque copies of the Document
-    numbering more than 100, you must either include a
-    machine-readable Transparent copy along with each Opaque copy, or
-    state in or with each Opaque copy a publicly-accessible
-    computer-network location containing a complete Transparent copy
-    of the Document, free of added material, which the general
-    network-using public has access to download anonymously at no
-    charge using public-standard network protocols.  If you use the
-    latter option, you must take reasonably prudent steps, when you
-    begin distribution of Opaque copies in quantity, to ensure that
-    this Transparent copy will remain thus accessible at the stated
-    location until at least one year after the last time you
-    distribute an Opaque copy (directly or through your agents or
-    retailers) of that edition to the public.</para>
-
-    <para>It is requested, but not required, that you contact the
-    authors of the Document well before redistributing any large
-    number of copies, to give them a chance to provide you with an
-    updated version of the Document.</para>
-  </sect1>
-
-  <sect1 label="4">
-    <title>MODIFICATIONS</title>
-
-    <para>You may copy and distribute a Modified Version of the
-    Document under the conditions of sections 2 and 3 above, provided
-    that you release the Modified Version under precisely this
-    License, with the Modified Version filling the role of the
-    Document, thus licensing distribution and modification of the
-    Modified Version to whoever possesses a copy of it.  In addition,
-    you must do these things in the Modified Version:</para>
-
-    <orderedlist numeration="upperalpha">
-      <listitem><para>Use in the Title Page
-      (and on the covers, if any) a title distinct from that of the
-      Document, and from those of previous versions (which should, if
-      there were any, be listed in the History section of the
-      Document).  You may use the same title as a previous version if
-      the original publisher of that version gives permission.</para>
-      </listitem>
-
-      <listitem><para>List on the Title Page,
-      as authors, one or more persons or entities responsible for
-      authorship of the modifications in the Modified Version,
-      together with at least five of the principal authors of the
-      Document (all of its principal authors, if it has less than
-      five).</para>
-      </listitem>
-
-      <listitem><para>State on the Title page
-      the name of the publisher of the Modified Version, as the
-      publisher.</para>
-      </listitem>
-
-      <listitem><para>Preserve all the
-      copyright notices of the Document.</para>
-      </listitem>
-
-      <listitem><para>Add an appropriate
-      copyright notice for your modifications adjacent to the other
-      copyright notices.</para>
-      </listitem>
-
-      <listitem><para>Include, immediately
-      after the copyright notices, a license notice giving the public
-      permission to use the Modified Version under the terms of this
-      License, in the form shown in the Addendum below.</para>
-      </listitem>
-
-      <listitem><para>Preserve in that license
-      notice the full lists of Invariant Sections and required Cover
-      Texts given in the Document's license notice.</para>
-      </listitem>
-
-      <listitem><para>Include an unaltered
-      copy of this License.</para>
-      </listitem>
-
-      <listitem><para>Preserve the section
-      entitled "History", and its title, and add to it an item stating
-      at least the title, year, new authors, and publisher of the
-      Modified Version as given on the Title Page.  If there is no
-      section entitled "History" in the Document, create one stating
-      the title, year, authors, and publisher of the Document as given
-      on its Title Page, then add an item describing the Modified
-      Version as stated in the previous sentence.</para>
-      </listitem>
-
-      <listitem><para>Preserve the network
-      location, if any, given in the Document for public access to a
-      Transparent copy of the Document, and likewise the network
-      locations given in the Document for previous versions it was
-      based on.  These may be placed in the "History" section.  You
-      may omit a network location for a work that was published at
-      least four years before the Document itself, or if the original
-      publisher of the version it refers to gives permission.</para>
-      </listitem>
-
-      <listitem><para>In any section entitled
-      "Acknowledgements" or "Dedications", preserve the section's
-      title, and preserve in the section all the substance and tone of
-      each of the contributor acknowledgements and/or dedications
-      given therein.</para>
-      </listitem>
-
-      <listitem><para>Preserve all the
-      Invariant Sections of the Document, unaltered in their text and
-      in their titles.  Section numbers or the equivalent are not
-      considered part of the section titles.</para>
-      </listitem>
-
-      <listitem><para>Delete any section
-      entitled "Endorsements".  Such a section may not be included in
-      the Modified Version.</para>
-      </listitem>
-
-      <listitem><para>Do not retitle any
-      existing section as "Endorsements" or to conflict in title with
-      any Invariant Section.</para>
-      </listitem>
-    </orderedlist>
-    
-    <para>If the Modified Version includes new front-matter sections
-    or appendices that qualify as Secondary Sections and contain no
-    material copied from the Document, you may at your option
-    designate some or all of these sections as invariant.  To do this,
-    add their titles to the list of Invariant Sections in the Modified
-    Version's license notice.  These titles must be distinct from any
-    other section titles.</para>
-
-    <para>You may add a section entitled "Endorsements", provided it
-    contains nothing but endorsements of your Modified Version by
-    various parties--for example, statements of peer review or that
-    the text has been approved by an organization as the authoritative
-    definition of a standard.</para>
-
-    <para>You may add a passage of up to five words as a Front-Cover
-    Text, and a passage of up to 25 words as a Back-Cover Text, to the
-    end of the list of Cover Texts in the Modified Version.  Only one
-    passage of Front-Cover Text and one of Back-Cover Text may be
-    added by (or through arrangements made by) any one entity.  If the
-    Document already includes a cover text for the same cover,
-    previously added by you or by arrangement made by the same entity
-    you are acting on behalf of, you may not add another; but you may
-    replace the old one, on explicit permission from the previous
-    publisher that added the old one.</para>
-
-    <para>The author(s) and publisher(s) of the Document do not by
-    this License give permission to use their names for publicity for
-    or to assert or imply endorsement of any Modified Version.</para>
-  </sect1>
-
-  <sect1 label="5">
-    <title>COMBINING DOCUMENTS</title>
-
-    <para>You may combine the Document with other documents released
-    under this License, under the terms defined in section 4 above for
-    modified versions, provided that you include in the combination
-    all of the Invariant Sections of all of the original documents,
-    unmodified, and list them all as Invariant Sections of your
-    combined work in its license notice.</para>
-
-    <para>The combined work need only contain one copy of this
-    License, and multiple identical Invariant Sections may be replaced
-    with a single copy.  If there are multiple Invariant Sections with
-    the same name but different contents, make the title of each such
-    section unique by adding at the end of it, in parentheses, the
-    name of the original author or publisher of that section if known,
-    or else a unique number.  Make the same adjustment to the section
-    titles in the list of Invariant Sections in the license notice of
-    the combined work.</para>
-
-    <para>In the combination, you must combine any sections entitled
-    "History" in the various original documents, forming one section
-    entitled "History"; likewise combine any sections entitled
-    "Acknowledgements", and any sections entitled "Dedications".  You
-    must delete all sections entitled "Endorsements."</para>
-  </sect1>
-
-  <sect1 label="6">
-    <title>COLLECTIONS OF DOCUMENTS</title>
-
-    <para>You may make a collection consisting of the Document and
-    other documents released under this License, and replace the
-    individual copies of this License in the various documents with a
-    single copy that is included in the collection, provided that you
-    follow the rules of this License for verbatim copying of each of
-    the documents in all other respects.</para>
-
-    <para>You may extract a single document from such a collection,
-    and distribute it individually under this License, provided you
-    insert a copy of this License into the extracted document, and
-    follow this License in all other respects regarding verbatim
-    copying of that document.</para>
-  </sect1>
-
-  <sect1 label="7">
-    <title>AGGREGATION WITH INDEPENDENT WORKS</title>
-    
-    <para>A compilation of the Document or its derivatives with other
-    separate and independent documents or works, in or on a volume of
-    a storage or distribution medium, does not as a whole count as a
-    Modified Version of the Document, provided no compilation
-    copyright is claimed for the compilation.  Such a compilation is
-    called an "aggregate", and this License does not apply to the
-    other self-contained works thus compiled with the Document, on
-    account of their being thus compiled, if they are not themselves
-    derivative works of the Document.</para>
-
-    <para>If the Cover Text requirement of section 3 is applicable to
-    these copies of the Document, then if the Document is less than
-    one quarter of the entire aggregate, the Document's Cover Texts
-    may be placed on covers that surround only the Document within the
-    aggregate.  Otherwise they must appear on covers around the whole
-    aggregate.</para>
-  </sect1>
-
-  <sect1 label="8">
-    <title>TRANSLATION</title>
-
-    <para>Translation is considered a kind of modification, so you may
-    distribute translations of the Document under the terms of section
-    4.  Replacing Invariant Sections with translations requires
-    special permission from their copyright holders, but you may
-    include translations of some or all Invariant Sections in addition
-    to the original versions of these Invariant Sections.  You may
-    include a translation of this License provided that you also
-    include the original English version of this License.  In case of
-    a disagreement between the translation and the original English
-    version of this License, the original English version will
-    prevail.</para>
-  </sect1>
-
-  <sect1 label="9">
-    <title>TERMINATION</title>
-    
-    <para>You may not copy, modify, sublicense, or distribute the
-    Document except as expressly provided for under this License.  Any
-    other attempt to copy, modify, sublicense or distribute the
-    Document is void, and will automatically terminate your rights
-    under this License.  However, parties who have received copies, or
-    rights, from you under this License will not have their licenses
-    terminated so long as such parties remain in full
-    compliance.</para>
-  </sect1>
-
-  <sect1 label="10">
-    <title>FUTURE REVISIONS OF THIS LICENSE</title>
-
-    <para>The Free Software Foundation may publish new, revised
-    versions of the GNU Free Documentation License from time to time.
-    Such new versions will be similar in spirit to the present
-    version, but may differ in detail to address new problems or
-    concerns.  See <ulink
-    url="http://www.gnu.org/copyleft/">http://www.gnu.org/copyleft/</ulink>.</para>
-
-    <para>Each version of the License is given a distinguishing
-    version number.  If the Document specifies that a particular
-    numbered version of this License "or any later version" applies to
-    it, you have the option of following the terms and conditions
-    either of that specified version or of any later version that has
-    been published (not as a draft) by the Free Software Foundation.
-    If the Document does not specify a version number of this License,
-    you may choose any version ever published (not as a draft) by the
-    Free Software Foundation.</para>
-  </sect1>
-
-  <sect1 label="">
-    <title>How to use this License for your documents</title>
-
-    <para>To use this License in a document you have written, include
-    a copy of the License in the document and put the following
-    copyright and license notices just after the title page:</para>
-
-<blockquote><para>
-      Copyright (c)  YEAR  YOUR NAME.
-      Permission is granted to copy, distribute and/or modify this document
-      under the terms of the GNU Free Documentation License, Version 1.1
-      or any later version published by the Free Software Foundation;
-      with the Invariant Sections being LIST THEIR TITLES, with the
-      Front-Cover Texts being LIST, and with the Back-Cover Texts being LIST.
-      A copy of the license is included in the section entitled "GNU
-      Free Documentation License".
-</para></blockquote>
-
-    <para>If you have no Invariant Sections, write "with no Invariant
-    Sections" instead of saying which ones are invariant.  If you have
-    no Front-Cover Texts, write "no Front-Cover Texts" instead of
-    "Front-Cover Texts being LIST"; likewise for Back-Cover
-    Texts.</para>
-
-    <para>If your document contains nontrivial examples of program
-    code, we recommend releasing these examples in parallel under your
-    choice of free software license, such as the GNU General Public
-    License, to permit their use in free software.</para>
-  </sect1>
-
-</appendix>